;;;
;;;
;;;	Author:
;;;		Henry C. Francis
;;;		425 N. Ashe St.
;;;		Southern Pines, NC 28387
;;;
;;;     http://paracadd.com
;;;	All rights reserved.
;;;
;;;	Copyright:  1991-2001
;;;	   Edited:  4-21-2010
;;;
;;;Writes activity lines to <dos root drive>:\ACAD\DWG_EDIT.LOG
;;;
;;;Requires:	DOSLIB incorporated by permission from Robert McNeel & Associates
;;;		http://www.en.na.mcneel.com/doslib.htm
;;;
(DEFUN dlog (/ tnam datm dwgp logf dwgn ostr curdt opl1 opl2 slen)
  (SETQ	princprfx (IF princprfx
		    (STRCAT princprfx "  ")
		    "[DEBUG]  "
		  ) ;_ end of IF
  ) ;_ end of SETQ
  (IF debug_princs
    (PROGN
      (PRINC (STRCAT "\n" princprfx "Begin DLOG function "))
      (PRINC)
    )
  )
  (IF check_for_doslib NIL (LOAD "check_for_doslib" "\nFile CHECK_FOR_DOSLIB.LSP not loaded! "))
  (check_for_doslib)
  (IF dos_sysdir
    (PROGN
      (SETQ dos_root_drive (CAR(dos_splitpath(dos_sysdir))))
      (DOS_DRIVE dos_root_drive)
      (DOS_CHDIR "\\")
      (DOS_MKDIR (STRCAT dos_root_drive "\\ACAD\\"))
      (SETQ tnam (IF onam
                   onam
                   (IF (AND DOS_USERNAME (DOS_USERNAME))
                     (DOS_USERNAME)
                     "Unknown"
                   ) ;_ end of if
                 ) ;_ end of if
      ) ;_ end of setq
      (SETQ dmach (IF DOS_COMPUTER
                    (STRCAT " on " (DOS_COMPUTER))
                    ""
                  ) ;_ end of if
      ) ;_ end of setq
      (SETQ datm (RTOS (GETVAR "cdate") 2 6))
      (SETQ dwgp  (GETVAR "dwgprefix")
            logf  (OPEN (STRCAT dos_root_drive "acad/dwg_edit.log") "a")
            dwgn  (GETVAR "dwgname")
      )
      (IF (AND prev_filespec (WCMATCH prev_filespec (STRCAT dwgp dwgn)))
        NIL
        (SETQ onam NIL)
      )
      (SETQ ostr  (IF onam
                    ""
                    "  Opened for editing....:  "
                  ) ;_ end of if
            curdt (STRCAT (SUBSTR datm 5 2)
                          "-"
                          (SUBSTR datm 7 2)
                          "-"
                          (SUBSTR datm 1 4)
                          "  "
                          (SUBSTR datm 10 2)
                          ":"
                          (SUBSTR datm 12 2)
                          ":"
                          (SUBSTR datm 14 2)
                  ) ;_ end of strcat
      )                                 ;setq
      (IF (= (SUBSTR dwgp 1 3) (SUBSTR dwgn 1 3))
        (SETQ
          slen (+ (- (STRLEN dwgn) (- (STRLEN dwgn) (STRLEN dwgp))) 1)
        ) ;_ end of setq
        (SETQ slen 1)
      )                                 ;if
      (IF (AND fstr (/= fstr ""))
        nil
        (IF (EQ ostr "")
          (SETQ fstr "  Activity not specified:  ")
          (SETQ fstr "")
        ) ;_ end of if
      ) ;_ end of if
      (SETQ
        opl1 (STRCAT dwgp
                     (SUBSTR dwgn slen)
                     (IF (WCMATCH (STRCASE dwgn) "*.DWG")
                       ""
                       ".DWG"
                     ) ;_ end of strcat
                     dmach
                     " "
                     (GETVAR "acadver")
                     " by: "
                     tnam
             ) ;_ end of strcat
      ) ;_ end of setq
      (IF (EQ ostr "  Opened for editing....:  ")
        (SETQ opl2 (STRCAT ostr curdt))
        (SETQ opl2 (STRCAT fstr curdt))
      ) ;_ end of if
      (IF onam
        nil
        (PROGN (WRITE-LINE "" logf)
               (WRITE-LINE opl1 logf)
        ) ;_ end of progn
      ) ;_ end of if
      (WRITE-LINE opl2 logf)
      (SETQ onam tnam)
      (IF logf
        (CLOSE logf)
      )
      (IF (OR
            (NOT log_it_dwgname)
            (AND
              (NOT (WCMATCH (STRCASE log_it_dwgname)(STRCASE (GETVAR "dwgname"))))
              (NOT actstr)
            )
          )
        (PROGN
          (IF log_it NIL (LOAD "log_it" "\nFile LOG_IT.LSP not loaded! "))
          (IF log_it
            (PROGN
              (SETQ actstr "OPENED")
              (log_it);This func may be cause of crashes during startup
            )
          )
        )
      )
      (SETQ prev_filespec (STRCAT dwgp dwgn))
      (PRINC)
    ) ;_ end of progn
  ) ;_ end of if
  (IF do_writelast NIL (LOAD "proj" "\nFile PROJ.LSP not loaded! "))
  (IF do_writelast
    (do_writelast)
  )
  (IF debug_princs
    (PROGN
      (PRINC (STRCAT "\n" princprfx "End DLOG function "))
      (PRINC)
    )
  )
  (SETQ	princprfx
	 (COND
	   ((AND princprfx (WCMATCH princprfx "`[DEBUG`]   *"))(SUBSTR princprfx 1 (-(STRLEN princprfx)2)))
	   (T "[DEBUG]  ")
	 ) ;_ end of COND
  ) ;_ end of SETQ
  (PRINC)
) ;_ end of defun
(PRINC)
