;;;
;;;
;;;	Author:
;;;		Henry C. Francis
;;;		425 N. Ashe St.
;;;		Southern Pines, NC 28387
;;;
;;;     http://paracadd.com
;;;	All rights reserved.
;;;
;;;At some point prior to the DEFUN/DEFUN-Q below the statement (COMMAND ".undefine" "qsave")
;;;is required or this DEFUN/DEFUN-Q will not redefine the internal QSAVE command.
;;;The statement (COMMAND ".undefine" "qsave") can be executed from here or anywhere
;;;else as long as it is called before this DEFUN/DEFUN-Q.
;;;
(DEFUN
  c:qsave
  (/ fstr)
  (SETQ princprfx (IF (AND debug_princs princprfx (< (STRLEN princprfx) 29))
                    (STRCAT princprfx "  ")
                    (IF debug_princs
                      "[DEBUG]  "
                      ""
                    ) ;_ end of IF
                  ) ;_ end of IF
  ) ;_ end of SETQ
  (IF princdebugstrs NIL (LOAD "princdebugstrs" "\nFile PRINCDEBUGSTRS.LSP not loaded! "))
  (princdebugstrs (LIST "Begin executing C:QSAVE function.\n"))
  (IF (EQ (GETVAR "VISRETAIN") 1)
    NIL
    (SETVAR "VISRETAIN" 1)
  )
  (IF c:dungroups
    nil
    (LOAD "groups" "\nFile GROUPS.LSP not loaded! ")
  )
  (c:dungroups);delete unnamed groups
  (c:demgroups);delete empty groups
    (COND ((and
           (OR (EQ (STRCASE (GETVAR "loginname")) "GRACKL")
               (EQ (STRCASE (GETVAR "loginname")) "CFRANCIS")
               (EQ (STRCASE (GETVAR "loginname")) "RENLOE")
           )
           (SETQ file_info (dos_file (strcat (getvar "dwgprefix")(getvar "dwgname"))))
         )
;;;         (if (and file_info (/=(GETVAR"LOGINNAME")"RSingletary")(<(IF (EQ (TYPE(CADR file_info)) 'REAL) (CADR file_info) (READ(CADR file_info)))3000000))(COMMAND ".AUDIT" "Y")))
         (if (and file_info (<(IF (OR (EQ (TYPE(CADR file_info)) 'REAL)(EQ (TYPE(CADR file_info)) 'INT)) (CADR file_info) (READ(CADR file_info)))350000))
;;;           (PROGN
;;;             (COMMAND ".AUDIT" "Y")
;;;           )
           (IF (and file_info (EQ (TYPE(CADR file_info)) 'REAL))
             (PROGN
               (PRINC (STRCAT "\nSkipped Audit!  File size is " (RTOS (CADR file_info) 2 0) " bytes. "))
               (PRINC "\nDrawing Files should be audited regularly! ")
               (PRINC)
             )
             (PRINC "\nDrawing Files should be audited regularly! ")
           )
         )
         (PRINC)
       )
  )
  (SETQ fstr "  QSaved................:  ")
  (IF c:lbl
    nil
    (LOAD "lbl")
  ) ;_ end of IF
  (SETQ cur_vp (GETVAR "cvport"))
  (IF (AND (EQ (GETVAR "tilemode") 0) (/= cur_vp 1))
    (COMMAND "_.pspace")
  ) ;_ end of if
  (IF (AND (SSGET "X" '((0 . "INSERT")
                        (2 . "???ttbats")
                       )
           )
           (NOT (OR
                  (WCMATCH (STRCASE (GETVAR "DWGNAME")) "?????X?#*.DWG")
                  (WCMATCH (STRCASE (GETVAR "DWGNAME")) "*BASE*.DWG")
                )
           )
      ) ;_ end of AND
    (SETVAR "DIMSCALE" 0)
  ) ;_ end of IF
  (IF dlog
    nil
    (LOAD "dlog" "\nFile DLOG.LSP not loaded! ")
  ) ;_ end of IF
  (princdebugstrs (LIST "Execute (DLOG) from inside C:QSAVE function.\n"))
  (dlog)
  (princdebugstrs (LIST "Done executing (DLOG) from inside C:QSAVE function.\n"))
  (SETQ fstr nil)
  (IF
    (OR (COND
          ((AND (NOT (WCMATCH (GETVAR "dwgname") "*\\*"))
                (NOT (WCMATCH (STRCASE (GETVAR "dwgname")) "*.DWG"))
                (EQ (STRLEN (GETVAR "dwgname")) 8)
           ) ;_ end of AND
           (AND (EQ "X"
                    (SUBSTR (STRCASE (GETVAR "dwgname")) 6 1) ;_ end of substr
                ) ;_ end of EQ
                (EQ "##"
                    (SUBSTR (GETVAR "dwgname") 7 2) ;_ end of substr
                ) ;_ end of EQ
           ) ;_ end of AND
          )
          ((AND (WCMATCH (STRCASE (GETVAR "dwgname")) "*.DWG") (EQ (STRLEN (GETVAR "dwgname")) 12))
           (AND (EQ "X"
                    (SUBSTR (STRCASE (GETVAR "dwgname")) (- (STRLEN (GETVAR "dwgname")) 6) 1) ;_ end of substr
                ) ;_ end of eq
                (EQ "##"
                    (SUBSTR (STRCASE (GETVAR "dwgname")) (- (STRLEN (GETVAR "dwgname")) 5) 2) ;_ end of substr
                ) ;_ end of eq
           ) ;_ end of AND
          )
          ((AND (WCMATCH (STRCASE (GETVAR "dwgname")) "*.DWG")
                (> (STRLEN (GETVAR "DWGNAME")) 12)
                (EQ "\\"
                    (SUBSTR (STRCASE (GETVAR "dwgname")) (- (STRLEN (GETVAR "dwgname")) 12) 1) ;_ end of substr
                ) ;_ end of EQ
           ) ;_ end of AND
           (AND
             (EQ "X"
                 (STRCASE (SUBSTR (GETVAR "dwgname") (- (STRLEN (GETVAR "dwgname")) 6) 1) ;_ end of substr
                 ) ;_ end of strcase
             ) ;_ end of eq
             (EQ "##"
                 (SUBSTR (STRCASE (GETVAR "dwgname")) (- (STRLEN (GETVAR "dwgname")) 5) 2) ;_ end of substr
             ) ;_ end of eq
           ) ;_ end of AND
          )
        ) ;_ end of COND
        (EQ "XBASE.DWG" (STRCASE (GETVAR "dwgname")))
        (SSGET "X" '((-4 . "<OR")(2 . "DAYSTAMP")(2 . "DSTAMP")(-4 . "<OR")))
        (EQ (GETVAR "TILEMODE") 1)
    ) ;_ end of or
     nil
     (PROGN
       (IF c:lbl
         nil
         (LOAD "lbl" "\nFIle LBL.LSP not loaded! ")
       ) ;_ end of IF
       (princdebugstrs (LIST "Execute C:LBL from inside C:QSAVE function.\n"))
       (c:lbl)
       (princdebugstrs (LIST "Done executing C:LBL from inside C:QSAVE function.\n"))
       (IF (EQ (SUBSTR (GETVAR "dwgprefix") 1 5) "\\10208\\21620")
         (PROGN (IF lvndx
                  nil
                  (LOAD "lvndx")
                ) ;_ end of if
                (lvndx)
         ) ;_ end of progn
         (PROGN
           (IF huandx
             nil
             (LOAD "huandx")
           ) ;_ end of if
           (princdebugstrs (LIST "Execute (HUANDX) from inside C:QSAVE function.\n"))
           (huandx)
           (princdebugstrs (LIST "Done executing (HUANDX) from inside C:QSAVE function.\n"))
         ) ;_ end of progn
       ) ;_ end of if
     ) ;_ end of progn
  ) ;_ end of if
  (IF (AND (EQ (GETVAR "tilemode") 0) (/= cur_vp 1))
    (COMMAND "_.mspace")
  ) ;_ end of if
  (IF align_lst
    (PROGN (SETQ num (LOAD_DIALOG "gpdgn")) (gate_dlg)) ;_ end of progn
  ) ;_ end of if
  (IF (SETQ ppgrid_ss (SSGET "X" '((0 . "INSERT")(2 . "*PPGRID*"))))
    (PROGN
      (SETQ ppgrid_cnt 0
            ppgrid_lays NIL
            fix_ppgrid NIL
      )
      (WHILE (< ppgrid_cnt (SSLENGTH ppgrid_ss))
        (SETQ ppgrid_ent (ENTGET (SSNAME ppgrid_ss ppgrid_cnt)))
        (IF (WCMATCH (STRCASE (CDR (ASSOC 8 ppgrid_ent))) "*NPLT*")
          (SETQ ppgrid_lays (APPEND ppgrid_lays (LIST (LIST (CDR (ASSOC 2 ppgrid_ent))(CDR (ASSOC 8 ppgrid_ent))))))
        )
        (SETQ ppgrid_cnt (1+ ppgrid_cnt))
      )
      (IF ppgrid_lays
        (PROGN
          (ALERT (STRCAT
                   (ITOA (LENGTH ppgrid_lays))
                   " Profile grid block"
                   (IF (> (LENGTH ppgrid_lays) 1) "s" "")
                   " found on non-plot (*NPLT*) layer"
                   (IF (> (LENGTH ppgrid_lays) 1) "s" "")
                   "!"
                 )
          )
          (SETQ fix_ppgrid (ukword 1 "Yes No" "Fix profile grid layers?" "Yes"))
          (IF (EQ (STRCASE fix_ppgrid) "YES")
            (PROGN
              (SETQ ppgrid_cnt 0)
              (WHILE (< ppgrid_cnt (SSLENGTH ppgrid_ss))
                (SETQ ppgrid_ent (ENTGET (SSNAME ppgrid_ss ppgrid_cnt)))
                (IF (WCMATCH (STRCASE (CDR (ASSOC 8 ppgrid_ent))) "*NPLT*")
                  (PROGN
                    (SETQ ppgrid_ent (SUBST (CONS 8 (CDR (ASSOC 2 ppgrid_ent)))(ASSOC 8 ppgrid_ent) ppgrid_ent))
                    (ENTMOD ppgrid_ent)
                  )
                )
                (SETQ ppgrid_cnt (1+ ppgrid_cnt))
              )
            )
          )
        )
      )
    )
  )
;;;  (IF log_it NIL (LOAD "log_it" "\nFile LOG_IT.LSP not loaded! "))
;;;  (IF log_it
;;;    (PROGN
;;;      (SETQ actstr "QSAVED")
;;;      (log_it);This func may be cause of crashes during startup
;;;    )
;;;  )
  (IF (EQ (STRCASE (GETVAR "dwgname")) "DRAWING.DWG")
    (PROGN
      (princdebugstrs (LIST "Execute (COMMAND \".SAVEAS\") from inside C:QSAVE function.\n"))
      (COMMAND ".saveas" "" "~")
      (princdebugstrs (LIST "Done executing (COMMAND \".SAVEAS\") from inside C:QSAVE function.\n"))
    ) ;_ end of PROGN
    (PROGN
      (princdebugstrs (LIST "Execute (COMMAND \".QSAVE\") from inside C:QSAVE function 1.\n"))
;;;      (PRINC "\nVIEWCTR = ")
;;;      (PRINC (GETVAR "VIEWCTR"))
;;;      (PRINC " before (COMMAND \".qsave\")")
;;;      (PRINC)
      (COMMAND ".qsave")
;;;      (PRINC "\nVIEWCTR = ")
;;;      (PRINC (GETVAR "VIEWCTR"))
;;;      (PRINC " after (COMMAND \".qsave\")")
;;;      (PRINC)
      (princdebugstrs (LIST "Done executing (COMMAND \".QSAVE\") from inside C:QSAVE function 1.\n"))
    ) ;_ end of PROGN
  ) ;_ end of if
  (IF (OR (EQ (GETVAR "dbmod") 0)(EQ (GETVAR "dbmod") 1))
    (PRINC (STRCAT "\n  " (STRCASE (GETVAR "dwgprefix")) (STRCASE (GETVAR "dwgname")) " saved." (IF(EQ (GETVAR "dbmod") 1)"(OBJ Database modified after save)" "") "\n"))
    (PROGN
      (PRINC "\nVIEWCTR = ")
      (PRINC (GETVAR "VIEWCTR"))
      (PRINC " before (COMMAND)")
      (PRINC)
      (COMMAND)
      (PRINC "\nVIEWCTR = ")
      (PRINC (GETVAR "VIEWCTR"))
      (PRINC " after (COMMAND) ")
      (PRINC)
      (princdebugstrs (LIST "Execute (COMMAND \".QSAVE\") from inside C:QSAVE function 2.\n"))
      (COMMAND ".qsave")
      (princdebugstrs (LIST "Done executing (COMMAND \".QSAVE\") from inside C:QSAVE function 2.\n"))
      (IF (OR (EQ (GETVAR "dbmod") 0)(EQ (GETVAR "dbmod") 1))
        (PROGN (PRINC (STRCAT "  " (STRCASE (GETVAR "dwgprefix")) (STRCASE (GETVAR "dwgname")) " saved." (IF(EQ (GETVAR "dbmod") 1)"(OBJ Database modified after save)" "") "\n") ; _ end of
                   ; strcat
               ) ;_ end of princ
        ) ;_ end of PROGN
        (ALERT (STRCAT "  " (STRCASE (GETVAR "dwgprefix")) (STRCASE (GETVAR "dwgname")) " NOT saved!\n") ;_ end of strcat
        ) ;_ end of princ
      ) ;_ end of if
;;;      (IF (EQ (GETVAR "dbmod") 0)
;;;        (PRINC
;;;          (STRCAT "\n  " (STRCASE (GETVAR "dwgprefix")) (STRCASE (GETVAR "dwgname")) " saved.\n")
;;;                                        ; _ end of
;;;                                        ; strcat
;;;        ) ;_ end of princ
;;;        (ALERT
;;;          (STRCAT "\n  "
;;;                  (STRCASE (GETVAR "dwgprefix"))
;;;                  (STRCASE (GETVAR "dwgname"))
;;;                  " NOT saved!\n"
;;;          ) ;_ end of STRCAT
;;;        ) ;_ end of princ
;;;      ) ;_ end of IF
    ) ;_ end of PROGN
  ) ;_ end of if
  (IF c:backup
    nil
    (LOAD "backup" "\nFile BACKUP.LSP not loaded! ")
  ) ;_ end of IF
  (princdebugstrs (LIST "Execute C:BACKUP from inside C:QSAVE function.\n"))
  (c:backup)
  (princdebugstrs (LIST "Done executing C:BACKUP from inside C:QSAVE function.\n"))
  (princdebugstrs (LIST "End executing C:QSAVE function.\n"))
  (SETQ princprfx
         (COND
           ((AND princprfx (WCMATCH princprfx "`[DEBUG`]   *"))
            (SUBSTR princprfx 1 (- (STRLEN princprfx) 2))
           )
           (debug_princs "[DEBUG]  ")
           (T "")
         ) ;_ end of COND
  ) ;_ end of SETQ
  (PRINC)
) ;_ end of defun
;;;**************************************************************************************************
;;;(DEFUN getauditdata ( / )
;;;  (IF vlax-ldata-get NIL (vl-load-com))
;;;  (SETQ lastaudit (vlax-ldata-get "auditdata" "lastaudit"))
;;;  (IF lastaudit
;;;    (SETQ audit-action (CAR lastaudit)
;;;          action-count (CADR lastaudit)
;;;          audit-time (CADDR lastaudit)
;;;    )
;;;    (SETQ audit-action "None"
;;;          action-count 0
;;;          audit-time "None"
;;;    )
;;;  )
;;;  (PROGN
;;;    (IF (EQ audit-time "None")
;;;      (SETQ audit_str "\nThis drawing has not been automatically audited yet.")
;;;      (SETQ audit_str (STRCAT "\nThis drawing was last automatically audited on " audit-time "."))
;;;    )
;;;    (IF (EQ audit-action "Skipped")
;;;      (SETQ audit_str (STRCAT audit-str " Audit was skipped just now. Drawings should be audited regularly! "))
;;;      (SETQ audit_str (STRCAT audit-str " An audit was just performed. "))
;;;    )
;;;  )  
;;;  (PRINC)
;;;)
;;;**************************************************************************************************
;;;(DEFUN putauditdata ( / )
;;;  (IF vlax-ldata-put NIL (vl-load-com))
;;;  (IF (AND audit-action action-count audit-time)
;;;    (PROGN
;;;      (COND ((EQ audit-action "None")
;;;             (IF did_audit
;;;               (SETQ audit_action "Audited"
;;;                     action-count 1
;;;                     audit-time (GETVAR "date")
;;;               )
;;;               (SETQ audit-action "Skipped"
;;;                     action-count 1
;;;               )
;;;             ))
;;;            ((EQ audit-action "Skipped")
;;;             (IF did_audit
;;;               (SETQ audit_action "Audited"
;;;                     action-count 1
;;;                     audit-time (GETVAR "date")
;;;               )
;;;               (SETQ action-count (1+ action-count))
;;;             ))
;;;            ((EQ audit-action "Audited")
;;;             (IF did_audit
;;;               (SETQ action-count 1 (1+ action-count)
;;;                     audit-time (GETVAR "date")
;;;               )
;;;               (SETQ audit-action "Skipped"
;;;                     action-count 1
;;;               )
;;;             ))
;;;      )
;;;      (SETQ lastaudit (vlax-ldata-put "auditdata" "lastaudit" (LIST audit-action action-count audit-time)))
;;;    )
;;;  )
;;;  (PRINC)
;;;)
;;;**************************************************************************************************

;|Visual LISP Format Options
(100 2 40 2 T "end of " 100 9 2 1 0 nil T nil T)
;*** DO NOT add text below the comment! ***|;
