;;;
;;;	Author:
;;;		Henry C. Francis
;;;		425 N. Ashe Street
;;;		Southern Pines, NC 28387
;;;
;;;	http://www.paracadd.com
;;;	copyright and all other rights reserved.
;;;     Edited: 11/17/2005
;;;
;;;"Bogus" lines may be used in the Index text file to create section headers
;;;but they must contain a tab for every column that normal lines have,
;;;(i.e., include a blank the description).
;;;
;;;UINT, UPOINT, MKLAYR, GVPNO, GETSTYLE, TXTSIZE
(defun SHTNDX_ERROR (msg /)
  (if old_shtndxerror
    (setq *ERROR* old_shtndxerror)
  ) ;_ end of IF
;;;  (IF SHTNDX_DIMSCALE (setvar "DIMSCALE" SHTNDX_DIMSCALE))
  (if SHTNDX_CMDECHO
    (setvar "CMDECHO" SHTNDX_CMDECHO)
  ) ;_ end of IF
  (if SHTNDX_OSMODE
    (setvar "OSMODE" SHTNDX_OSMODE)
  ) ;_ end of IF
  (princ "\nERROR: ")
  (princ msg)
  (princ)
) ;_ end of defun
(defun c:shtndx	(/	    tag_lst    ndx_line	  red_line   note_offd
		 note_len   new_len    note_lst	  start_pt   cbpt2
		 cbpt3	    cbpt4      cnpt1	  cnpt1a     hdrpt1
		 hdrpt1a    ttl_pt     cnpt2	  cnpt2a     cccnpt3
		 cnpt3a	    cnpt4      cnpt4a	  cnpt5	     cnpt5a
		 cnpt6	    cnpt6a     cnpt7	  cnpt7a     cnpt8
		 cnpt8a	    cnpt9      cnpt9a	  cnpt10     cnpt10a
		 note_txt   str_cnt    str_offd	  scnpt1     scnpt1a
		 column_base	       ndx_file	  note_ofil
		)
  (setq old_shtndxerror *ERROR*)
  (setq *ERROR* SHTNDX_ERROR)
  (setq SHTNDX_OSMODE (getvar "OSMODE"))
  (setq OLD_CMDECHO (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
;;;  (setvar "DIMSCALE" 1.0)
  (if dimscl
    NIL
    (load "dimscl" "\nFile DIMSCL.LSP not loaded! ")
  ) ;_ end of IF
  (dimscl)
  (if uint
    NIL
    (load "uint" "\nFile UINT.LSP not loaded! ")
  ) ;_ end of IF
  (if upoint
    NIL
    (load "upoint" "\nFile UPOINT.LSP not loaded! ")
  ) ;_ end of IF
  (if c:mklayr
    NIL
    (load "mklayr" "\nFile MKLAYR.LSP not loaded! ")
  ) ;_ end of IF
  (setq	ndx_file (getfiled "Sheet Index File"
			   (strcat (getvar "dwgprefix") "huandx.txt")
			   "txt"
			   0
		 ) ;_ end of getfiled
  ) ;_ end of setq
  (setq	wraplen	(uint 1
		      ""
		      "Note word wrap length"
		      (if wraplen
			wraplen
			50.0
		      ) ;_ end of if
		) ;_ end of uint
  ) ;_ end of setq
  (if getstyle
    NIL
    (load "getstyle")
  ) ;_ end of IF
  (setq					;llt   "-"
    colr	    "1"
    colra	    nil
    colri	    nil
    txtht	    (getvar "textsize")
    numb	    0
    modf	    "TEXT"
    col_head_hgt    0.14
    title_hgt	    0.18
    ent_assoc_8_lst NIL
  ) ;_ end of SETQ
  (if gvpno
    nil
    (load "gvpno")
  ) ;_ end of if
  (gvpno)
  (if mjrg
    nil
    (setq mjrg "G")
  ) ;_ end of IF
  (if txtsize
    nil
    (load "txtsize" "\nFile TXTSIZE.LSP not found! ")
  ) ;_ end of if
  (txtsize nil)
  (getstyle "A")
  (setq colr lncolr)
  (c:svlayr)
  (command ".undo" "begin")
  (setq	start_pt
	 (upoint
	   1				""
	   "Pick point for upper left corner of Index"
	   nil				nil
	  ) ;_ end of upoint
 ;_ end of upoint
 ;_ end of upoint
 ;_ end of upoint
  ) ;_ end of setq
  (setq	column_base
	 (upoint
	   1			 ""
	   "Pick point for bottom of Index"
	   nil			 start_pt
	  ) ;_ end of upoint
 ;_ end of upoint
 ;_ end of upoint
 ;_ end of upoint
  ) ;_ end of setq
  (setvar "OSMODE" 0)
  (setq col_wid (* dimsc 0.5 (/ (atof thts) 100.0)))
  (setq	cnpt1	(polar
		  (polar start_pt
			 (- 0 (getvar "viewtwist"))
			 (* dimsc 4.0 (/ (atof thts) 1000.0))
		  ) ;_ end of polar
		  (- 0 (getvar "viewtwist") (* pi 0.5))
		  (* dimsc 1.5 (/ (atof thts) 1000.0))
					;(+ (* dimsc 0.5 (/ (atof thts) 1000.0)) (* txtht dimsc))
		) ;_ end of polar
	cnpt1a	(polar cnpt1 (- 0 (getvar "viewtwist")) (* 1.0 col_wid))
	hdrpt1	(polar
		  (polar start_pt
			 (- 0 (getvar "viewtwist"))
			 (* dimsc 4.0 (/ (atof thts) 1000.0))
		  ) ;_ end of polar
		  (- 0 (getvar "viewtwist") (* pi 1.5))
		  (* dimsc 1.0 title_hgt)
					;(* dimsc 0.2 (/ (atof thts) 1000.0))
		) ;_ end of polar
	hdrpt1a	(polar hdrpt1 (- 0 (getvar "viewtwist")) (* 1.0 col_wid))
  ) ;_ end of setq
  (if ndx_file
    (setq note_ofil (open ndx_file "r"))
    (setq note_ofil (open (findfile "huandx.txt") "r"))
  ) ;_ end of if
  (while
    (and note_ofil
	 (setq ndx_line (read-line note_ofil))
	 (wcmatch (strcase ndx_line) "*DWG*")
    ) ;_ end of AND
     (while (and (/= (substr ndx_line 1 1) "\t")
		 (/= (substr ndx_line 1 1) "\\")
	    ) ;_ end of and
       (setq ndx_line (substr ndx_line 2))
     ) ;_ end of while
     (setq strstep 2)
     (while (and (/= (substr ndx_line strstep 1) "\t")
		 (/= (substr ndx_line strstep 1) "\\")
	    ) ;_ end of and
       (setq strstep (1+ strstep))
     ) ;_ end of while
     (setq vpstep (1+ strstep))
     (if
       (or
	 (wcmatch (substr ndx_line vpstep)
		  "*\t*"
	 ) ;_ end of wcmatch
	 (wcmatch (substr ndx_line vpstep)
		  "*\\*"
	 ) ;_ end of wcmatch
       ) ;_ end of or
	(progn
	  (while (and
		   (/= (substr ndx_line vpstep 1) "\t")
		   (/= (substr ndx_line vpstep 1) "\\")
		 ) ;_ end of and
	    (setq vpstep (1+ vpstep)
	    ) ;_ end of setq
	  ) ;_ end of while
	  (setq	sht_no	 (strcase (substr ndx_line 2 (- strstep 2)))
		vp_line	 (substr ndx_line (1+ vpstep))
		ndx_line (strcase
			   (substr ndx_line (1+ strstep) (- vpstep strstep 1))
			 ) ;_ end of strcase
	  ) ;_ end of setq
	) ;_ end of progn
	(setq sht_no   (strcase (substr ndx_line 2 (- strstep 2)))
	      ndx_line (strcase (substr ndx_line (1+ strstep)))
	) ;_ end of setq
     ) ;_ end of if
     (if note_lst
       (setq
	 note_lst (append
		    note_lst
		    (list (cons sht_no ndx_line))
		  ) ;_ end of append
       ) ;_ end of setq
       (setq note_lst (list (cons sht_no ndx_line)))
     ) ;_ end of if
  ) ;_ end of while
  (if note_ofil
    (progn
      (close note_ofil)
      (setq cnt 1)
      (setq shtndx_ss (ssadd))
      (column_headings)
      (setq cnt	      1
	    horzoffd  0.0
	    start_pt2 start_pt
      ) ;_ end of setq
      (setq llt	 "-"
	    prod "SHTX"
	    colr txcolr
	    modf "TEXT"
      ) ;_ end of setq
      (c:mklayr)
      (foreach n note_lst
	(if (member (car n)
		    '("GENERAL"	       "CIVIL"
		      "STRUCTURAL"     "ARCHITECTURAL"
		      "P&ID"	       "ENVIRONMENTAL"
		      "TELEMETRY"      "ELECTRICAL"
		      "MECHANICAL"     "PLUMBING"
		      "FIRE"	       "LANDSCAPE"
		      "HVAC"
		     )
	    ) ;_ end of MEMBER
	  (setq v_factor 2.2)
	  (setq v_factor 1.1)
	) ;_ end of IF
	(set (read (strcat "cnpt" (itoa (1+ cnt))))
	     (polar (eval (read (strcat "cnpt" (itoa cnt))))
		    (- 0 (getvar "viewtwist") (* pi 0.5))
		    (* dimsc v_factor (/ (atof thts) 1000.0))
					;(* 1.0 0.22 (/ (atof thts) 100.0))
	     ) ;_ end of polar
	) ;_ end of set
	(set (read (strcat "cnpt" (itoa (1+ cnt)) "a"))
	     (polar (eval (read (strcat "cnpt" (itoa cnt) "a")))
		    (- 0 (getvar "viewtwist") (* pi 0.5))
		    (* dimsc v_factor (/ (atof thts) 1000.0))
					;(* 1.0 0.22 (/ (atof thts) 100.0))
	     ) ;_ end of polar
	) ;_ end of set
;;;	(setq cnt (1+ cnt)) ;_ end of setq
;;;      ) ;_ end of foreach
;;;      (foreach n note_lst
	(if (<
	      (distance start_pt column_base)
	      (distance	start_pt2
			(polar
			  (polar
			    (eval (read (strcat "cnpt" (itoa cnt))))
			    (- 0 (getvar "viewtwist") (* pi 0.5))
			    (if	note_offd
			      note_offd
			      0
			    ) ;_ end of if
			  ) ;_ end of polar
			  (- 0 (getvar "viewtwist"))
			  horzoffd
			) ;_ end of polar
	      ) ;_ end of distance
	    ) ;_ end of <
	  (progn
	    (setq note_offd (- (distance
				 (eval (read (strcat "cnpt" (itoa cnt))))
				 cnpt1
			       ) ;_ end of DISTANCE
			    ) ;_ end of -
		  str_offd  0.0
		  horzoffd  (+ horzoffd
			       (distance cnpt1 cnpt1a)
			       (* dimsc 0.25)
			       (* dimsc wraplen (/ (atof thts) 1000.0))
			    ) ;_ end of +
		  start_pt2 (polar start_pt
				   (- 0 (getvar "viewtwist"))
				   horzoffd
			    ) ;_ end of polar
	    ) ;_ end of setq
	    (column_headings)
	  ) ;_ end of progn
	) ;_ end of if
	(setq ntxt_pt1
	       (polar
		 (polar
		   (eval (read (strcat "cnpt" (itoa cnt))))
		   (- 0 (getvar "viewtwist") (* pi 0.5))
		   (if note_offd
		     note_offd
		     0
		   ) ;_ end of if
		 ) ;_ end of polar
		 (- 0 (getvar "viewtwist"))
		 horzoffd
	       ) ;_ end of polar
	) ;_ end of setq
	(setq ent_assoc_8     (cons 8
				    (strcat mjrg llt "SHTX" "4"	modf) ;_ end of STRCAT
 ;_ end of STRCAT
			      ) ;_ end of CONS
	      ent_assoc_8_lst (if (and ent_assoc_8_lst
				       (member ent_assoc_8 ent_assoc_8_lst)
				  ) ;_ end of AND
				ent_assoc_8_lst
				(append ent_assoc_8_lst (list ent_assoc_8))
			      ) ;_ end of IF
	) ;_ end of SETQ
	(cond
	  ((member (car n)
		   '("GENERAL"	      "CIVIL"	       "STRUCTURAL"
		     "ARCHITECTURAL"  "P&ID"	       "ENVIRONMENTAL"
		     "TELEMETRY"      "ELECTRICAL"     "MECHANICAL"
		     "PLUMBING"	      "FIRE"	       "LANDSCAPE"
		     "HVAC"
		    )
	   ) ;_ end of MEMBER
	   (setq ntxt_pt1 (polar ntxt_pt1
				 (- 0 (getvar "viewtwist") (* pi 0.5))
				 (* txtht 1.0)
			  ) ;_ end of POLAR
	   ) ;_ end of SETQ
	   (entmake
	     (list (cons 0 "TEXT")
		   ent_assoc_8
		   (cons 10 ntxt_pt1)
		   (cons 7 (getvar "textstyle"))
;;;                                   (CONS 11 ntxt_pt1)
		   (cons 72 0)
		   (cons 73 0)
		   (cons 40 (* dimsc col_head_hgt))
		   (cons 50 (- 0 (getvar "viewtwist")))
		   (cons 51 0)
		   (cons 1 (car n))
	     ) ;_ end of LIST
	   ) ;_ end of ENTMAKE
	  )
	  (t
	   (command ".text"
		    "j"
		    "ml"
		    ntxt_pt1
		    (* txtht 1.0)
		    (* (/ (- 0 (getvar "viewtwist")) pi) 180)
		    (car n)
	   ) ;_ end of command
	  )
	) ;_ end of COND
	(ssadd (entlast) shtndx_ss)
	(setq note_txt (cdr n))
	(ndxbrkstr note_txt wraplen)
	(setq str_cnt 1)
	(repeat	var_indx
	  (setq str_offd (* (1- str_cnt) (* 1.5 txtht 1.0)))
	  (setq	ntxt_pt2
		 (polar
		   (polar
		     (eval (read (strcat "cnpt" (itoa cnt) "a")))
		     (- 0 (getvar "viewtwist") (* pi 0.5))
		     (if note_offd
		       note_offd	;(+ note_offd str_offd)
		       str_offd
		     ) ;_ end of if
		   ) ;_ end of polar
		   (- 0 (getvar "viewtwist"))
		   horzoffd
		 ) ;_ end of polar
	  ) ;_ end of setq
	  (command ".text"
		   "j"
		   "ml"
		   ntxt_pt2
		   (* txtht 1.0)
		   (* (/ (- 0 (getvar "viewtwist")) pi) 180)
		   (eval (read (strcat "typ_t" (itoa str_cnt))))
	  ) ;_ end of command
;;;(SET (read (strcat "cnpt" (itoa cnt) "a")) ntxt_pt2)
	  (ssadd (entlast) shtndx_ss)
	  (setq str_cnt (1+ str_cnt))
	  (if note_len
	    (if
	      (> (setq
		   new_len
		    (distance (car (textbox (entget (entlast))))
			      (cadr (textbox (entget (entlast))))
		    ) ;_ end of DISTANCE
		 ) ;_ end of setq
		 note_len
	      ) ;_ end of >
	       (setq note_len new_len)
	    ) ;_ end of if
	    (setq
	      note_len (distance (car (textbox (entget (entlast))))
				 (cadr (textbox (entget (entlast))))
		       ) ;_ end of DISTANCE
	    ) ;_ end of setq
	  ) ;_ end of if
	  (if note_offd
	    (setq note_offd (+ note_offd (* 1.5 txtht)))
	    (setq note_offd (* 1.5 txtht))
	  ) ;_ end of if
	) ;_ end of repeat
	(setq cnt      (1+ cnt)
	      box_botm (polar (cdr (assoc 10 (entget (entlast))))
			      (- 0 (getvar "viewtwist") (* pi 0.5))
			      (* txtht 1.5)
		       ) ;_ end of polar
	) ;_ end of setq
      ) ;_ end of foreach
      (setq cbpt2   (polar start_pt
			   (- 0 (getvar "viewtwist"))
			   (+ (* 1.0 1.5875) note_len)
		    ) ;_ end of polar
	    tmp_pt1 (polar cbpt2 (- 0 (getvar "viewtwist") (* pi 0.5)) 10)
	    tmp_pt2 (polar box_botm (- 0 (getvar "viewtwist")) 10)
	    cbpt3   (inters cbpt2 tmp_pt1 box_botm tmp_pt2 nil)
	    cbpt4   (polar cbpt3
			   (angle cbpt2 start_pt)
			   (+ (* dimsc 1.5875) note_len)
		    ) ;_ end of polar
	    ttl_pt  (polar
		      (polar start_pt
			     (- 0 (getvar "viewtwist"))
			     (/	(+ (distance oldhdrpt1 oldhdrpt1a)
				   (* dimsc 0.25)
				   (* dimsc (/ (atof thts) 1000.0))
				   (* dimsc wraplen (/ (atof thts) 1000.0))
				   (distance start_pt start_pt2)
				) ;_ end of +
				2
			     ) ;_ end of /
		      ) ;_ end of polar
		      (- 0 (getvar "viewtwist") (* pi 1.5))
		      (* dimsc 3.0 col_head_hgt)
		    ) ;_ end of polar
      ) ;_ end of setq
      (setq colr "2")
      (c:mklayr)
      (command ".text"
	       "j"
	       "c"
	       ttl_pt
	       (* dimsc title_hgt)	;(* txtht 1.8)
	       (* (/ (- 0 (getvar "viewtwist")) pi) 180)
	       "INDEX OF SHEETS"
      ) ;_ end of command
      (ssadd (entlast) shtndx_ss)
      (command
	".line"
	(polar start_pt
	       (- 0 (getvar "viewtwist") (* pi 1.5))
	       (- (* dimsc 3.0 col_head_hgt) (* dimsc 0.5 title_hgt))
					;(* dimsc (/ (atof thts) 1000.0))
	) ;_ end of POLAR
	(polar
	  (polar start_pt
		 (- 0 (getvar "viewtwist"))
		 (+ (distance oldhdrpt1 oldhdrpt1a)
		    (* dimsc 0.25)
		    (* dimsc (/ (atof thts) 1000.0))
		    (* dimsc wraplen (/ (atof thts) 1000.0))
		    (distance start_pt start_pt2)
		 ) ;_ end of +
	  ) ;_ end of POLAR
	  (- 0 (getvar "viewtwist") (* pi 1.5))
	  (- (* dimsc 3.0 col_head_hgt) (* dimsc 0.5 title_hgt))
					;(* dimsc (/ (atof thts) 1000.0))
	) ;_ end of POLAR
	""
      ) ;_ end of command
      (ssadd (entlast) shtndx_ss)
      (setq grp_name_a (rtos (fix (getvar "cdate")) 2 0)
	    grp_name_b (substr (rtos (rem (getvar "cdate") 1) 2 8) 3)
	    grp_name_c "_INDEX"
      ) ;_ end of setq
      (command "-group"
	       "create"
	       (strcat grp_name_a grp_name_b grp_name_c)
	       "Sheet Index"
	       shtndx_ss
	       ""
      ) ;_ end of COMMAND
    ) ;_ end of progn
    (princ (strcat "\nRequired file "
		   (getvar "dwgprefix")
		   "HUANDX.TXT not found! "
	   ) ;_ end of strcat
    ) ;_ end of princ
  ) ;_ end of if
  (shtndx_layer_ent ent_assoc_8_lst)
  (command ".undo" "end")
  (if old_shtndxerror
    (setq *ERROR* old_shtndxerror)
  ) ;_ end of IF
;;;  (IF SHTNDX_DIMSCALE (setvar "DIMSCALE" SHTNDX_DIMSCALE))
  (if SHTNDX_OSMODE
    (setvar "OSMODE" SHTNDX_OSMODE)
  ) ;_ end of IF
  (if SHTNDX_CMDECHO
    (setvar "CMDECHO" SHTNDX_CMDECHO)
  ) ;_ end of IF
  (c:rslayr)
  (clr_txt)
  (princ)
) ;_ end of defun
(defun ndxbrkstr (note wrap /)
  (progn
    (setq chr_indx 1
	  var_indx 1
    ) ;_ end of setq
    (setq nxt_char (substr note chr_indx 1))
    (while (and (not note_done) (not (eq "" note)))
      (if (eq nxt_char " ")		;if breakpoint
	(progn
	  (if lst_break
	    (setq fst_break lst_break)
	  ) ;_ end of if
	  (setq lst_break chr_indx)
	) ;_ end of progn
      ) ;_ end of if
      (if (eq nxt_char "")		;if endpoint
	(progn
	  (if lst_break
	    (setq fst_break lst_break)
	  ) ;_ end of if
	  (setq	lst_break chr_indx
		done_note t
	  ) ;_ end of setq
	) ;_ end of progn
      ) ;_ end of if
      (cond
	((> lst_break wrap)
	 (set (read (strcat "typ_t" (itoa var_indx)))
	      (substr note 1 (1- fst_break))
	 ) ;_ end of set
	 (setq note	 (substr note (1+ fst_break))
	       chr_indx	 1
	       var_indx	 (1+ var_indx)
	       fst_break nil
	       lst_break nil
	       nxt_char	 (substr note 1 1)
	 ) ;_ end of setq
	)
	((eq lst_break wrap)		;if 2nd break = wrap length
	 (set (read (strcat "typ_t" (itoa var_indx)))
	      (substr note 1 (1- lst_break))
	 ) ;_ end of set
	 (if (> (strlen note) wrap)
	   (setq note	   (substr note (1+ lst_break))
		 chr_indx  1
		 var_indx  (1+ var_indx)
		 fst_break nil
		 lst_break nil
		 nxt_char  (substr note 1 1)
	   ) ;_ end of setq
	   (setq nxt_char ""
		 note_done t
	   ) ;_ end of setq
	 ) ;_ end of if
	)
	((<= (strlen note) wrap)
	 (set (read (strcat "typ_t" (itoa var_indx)))
	      note
	 ) ;_ end of set
	 (setq
	   nxt_char
		     ""
	   note_done
		     t
	 ) ;_ end of setq
	) ;_ end of cond
      ) ;_ end of cond
      (setq chr_indx (1+ chr_indx)
	    nxt_char (substr note chr_indx 1)
      ) ;_ end of setq
    ) ;_ end of while
    (if	note_done
      (setq note_done nil)
      (progn
	(set (read (strcat "typ_t" (itoa var_indx)))
	     note
	) ;_ end of set
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of progn
) ;_ end of defun
(defun clr_txt ()
  (setq
    typ_t1 nil
    typ_t2 nil
    typ_t3 nil
    typ_t4 nil
    typ_t5 nil
    typ_t6 nil
    typ_t7 nil
    typ_t8 nil
    typ_t9 nil
    typ_t10 nil
    typ_t11 nil
    typ_t12 nil
    typ_t13 nil
    fst_break nil
    lst_break nil
  ) ;_ end of setq
) ;_ end of defun
(defun column_headings ()
  (setq	llt  "-"
	prod "SHTX"
	colr "4"
	modf "TEXT"
  ) ;_ end of setq
  (c:mklayr)
  (command ".text"
	   "j"
	   "ml"
	   hdrpt1			; (POLAR hdrpt1 (+ PI(- 0 (GETVAR "VIEWTWIST"))) (* txtht 2.0))
	   (* dimsc col_head_hgt)	;(* txtht 1.27)
	   (* (/ (- 0 (getvar "viewtwist")) pi) 180)
	   "SHEET NO."
  ) ;_ end of command
  (ssadd (entlast) shtndx_ss)
  (command ".text"
	   "j"
	   "ml"
	   (polar hdrpt1a
		  (- 0 (getvar "VIEWTWIST"))
		  (* 10.0 dimsc col_head_hgt)
	   ) ;_ end of POLAR
	   (* dimsc col_head_hgt)	;(* txtht 1.27)
	   (* (/ (- 0 (getvar "viewtwist")) pi) 180)
	   "TITLE"
  ) ;_ end of command
  (ssadd (entlast) shtndx_ss)
  (setq	oldhdrpt1  hdrpt1
	oldhdrpt1a hdrpt1a
	hdrpt1	   (polar hdrpt1
			  (- 0 (getvar "viewtwist"))
			  (+ (distance oldhdrpt1 oldhdrpt1a)
			     (* dimsc 0.25)
			     (* dimsc wraplen (/ (atof thts) 1000.0))
			  ) ;_ end of +
		   ) ;_ end of polar
	hdrpt1a	   (polar hdrpt1a
			  (- 0 (getvar "viewtwist"))
			  (+ (distance oldhdrpt1 oldhdrpt1a)
			     (* dimsc 0.25)
			     (* dimsc wraplen (/ (atof thts) 1000.0))
			  ) ;_ end of +
		   ) ;_ end of polar
  ) ;_ end of setq
  (setq	llt  "-"
	prod "SHTX"
	colr txcolr
	modf "TEXT"
  ) ;_ end of setq
  (c:mklayr)
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun c:mergendx ()
  (setq
    ndx_dirini t
    ndx_caldir nil
    ndx_selndi nil
  ) ;_ end of setq
  (setq old_mndxecho (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (cond
    ((and (= (atoi (substr (getvar "acadver") 1 2)) 15)
	  (not dos_ver)
     ) ;_ end of and
     (arxload "doslib15")
    )
    ((and (= (atoi (substr (getvar "acadver") 1 2)) 16)
	  (not dos_ver)
     ) ;_ end of and
     (arxload "doslib16")
    )
    ((and (= (atoi (substr (getvar "acadver") 1 2)) 17)
	  (not dos_ver)
     ) ;_ end of and
     (arxload "doslib17")
    )
  ) ;_ end of cond
  (progn
;;;    (if	ndxins_fname
;;;      nil
;;;      (setq ndxins_fname "0")
;;;    ) ;_ end of IF
					;  (setq ndxorgdrv (dos_drive))
    (setq ndxorgdrv (substr (getvar "dwgprefix") 1 2))
    (if	debug_doslib
      (princ "\nDOS_1 ")
    ) ;_ end of IF
    (dos_drive ndxorgdrv)
    (if	debug_doslib
      (princ "\nDOS_1 ")
    ) ;_ end of IF
					;  (setq ndxorgdir (dos_pwdir))
    (setq ndxorgdir (getvar "dwgprefix"))
    (if	debug_doslib
      (princ "\nDOS_2 ")
    ) ;_ end of IF
    (dos_chdir (substr ndxorgdir 4))
    (if	debug_doslib
      (princ "\nDOS_2 ")
    ) ;_ end of IF
    (setq ndxdirstr (strcat "Selection path: " (getvar "dwgprefix"))
					;(DOS_PWDIR)
	  olddir ndxdirstr
    ) ;_ end of setq
    (if	debug_doslib
      (princ "\nDOS_3 ")
    ) ;_ end of IF
    (setq ndx_ddirs (dos_subdir (getvar "dwgprefix")))
    (setq ndx_d_flst (dos_dir (strcat (getvar "dwgprefix") "*.txt")))
    (if	debug_doslib
      (princ "\nDOS_3 ")
    ) ;_ end of IF
    (if	(eq (substr ndxdirstr (1- (strlen ndxdirstr))) ":\\")
      (if ndx_ddirs
	nil
	(setq ndx_ddirs (list ""))
      ) ;_ end of if
      (if ndx_ddirs
	(if (member ".." ndx_ddirs)
	  nil
	  (setq ndx_ddirs (append (list "..") ndx_ddirs))
	) ;_ end of if
	(setq ndx_ddirs (list ".."))
      ) ;_ end of if
    ) ;_ end of if
    (if	debug_doslib
      (princ "\nDOS_4 ")
    ) ;_ end of IF
    (setq ndx_ddrvs (dos_drives))
    (if	debug_doslib
      (princ "\nDOS_4 ")
    ) ;_ end of IF
    (if	(member "A:" ndx_ddrvs)
      (setq ndx_ddrvs (cdr (member "A:" ndx_ddrvs)))
    ) ;_ end of if
    (if	(member "B:" ndx_ddrvs)
      (setq ndx_ddrvs (cdr (member "B:" ndx_ddrvs)))
    ) ;_ end of if
    (setq ndx_num (load_dialog "mergendx"))
    (new_dialog "mergendx" ndx_num)
    (set_tile "dirtxt" ndxdirstr)
    (ndx_drvlst)
    (start_list "ndx_file_drv")
    (mapcar 'add_list ndx_avdrvs)
    (end_list)
    (setndxfdrv)
    (ndx_sortfiles)
    (if	ndx_sortdate
      nil
      (setq ndx_sortdate "0")
    ) ;_ end of IF
    (set_tile "sortdate" ndx_sortdate)
    (setq ndx_curdwg (getvar "dwgname"))
    (setq ndx_curpfx (getvar "dwgprefix"))
    (if	debug_doslib
      (princ "\nDOS_5 ")
    ) ;_ end of IF
    (setq sndxpat (dos_splitpath ndx_curdwg))
    (if	debug_doslib
      (princ "\nDOS_5 ")
    ) ;_ end of IF
    (if	dos_win
      (if (eq (dos_win) "WINNT")
	(setq nt_true t)
	(setq nt_true nil)
      ) ;_ end of if
      (if dos_ver
	(if (eq (dos_ver) "Windows NT Workstation 4.0")
	  (setq nt_true t)
	  (setq nt_true nil)
	) ;_ end of if
	(setq nt_true nil)
      ) ;_ end of if
    ) ;_ end of if
    (if	nt_true
      (if (= (length sndxpat) 4)
	(setq ndx_curdwg (strcat (nth 2 sndxpat) (nth 3 sndxpat)))
      ) ;_ end of if
      (if (eq (substr ndx_curdwg 1 2) (substr ndx_curpfx 1 2))
	(setq ndx_curdwg
	       (strcat
		 (substr ndx_curdwg (1+ (strlen ndx_curpfx)))
		 (if (wcmatch (strcase ndx_curdwg) "*.txt")
		   ""
		   ".txt"
		 ) ;_ end of IF
	       ) ;_ end of STRCAT
	) ;_ end of SETQ
	(setq ndx_curdwg (strcat
		       ndx_curdwg
		       (if (wcmatch (strcase ndx_curdwg) "*.txt")
			 ""
			 ".txt"
		       ) ;_ end of IF
		     ) ;_ end of STRCAT
	) ;_ end of SETQ
      ) ;_ end of if
    ) ;_ end of if
    (mode_tile "ndx_fedit" 2)
    (action_tile "ndx_dirs" "(setq ndx_caldir $reason)(ndx_dirlst)")
    (action_tile
      "ndx_fedit"
      "(setq ndxndx NIL)(if(eq $reason 2)nil(progn(mergendx_key_search nil)(ndx_chkfil)))"
					;Was (mergendx_key_search ndx_out_filn)
    ) ;_ end of action_tile
    (action_tile "ndx_files" "(ndx_chkfil)")
    (action_tile
      "sortdate"
      "(setq ndx_sortdate (get_tile\"sortdate\"))(ndx_sortfiles)"
    ) ;_ end of ACTION_TILE
    (action_tile
      "selall"
      "(set_tile\"fedit\"\"*\")(mergendx_key_search ndx_out_filn)(ndx_chkfil)"
    ) ;_ end of action_tile
    (action_tile
      "clear"
      "(setq cur_ndxlst nil)(setq ndx_selndi \"\")(setrem)(set_tile\"files\"\"\")(set_tile\"error\"\"\")"
					;did include (set_tile\"fedit\"\"\")
    ) ;_ end of action_tile
    (action_tile
      "ndx_file_drv"
      "(SETQ ndx_fildrv(NTH(READ(GET_TILE\"file_drv\"))ndx_avdrvs))(setndxfdrv)"
    ) ;_ end of ACTION_TILE
    (action_tile "remove" "(setrem)")
    (action_tile "reverse" "(revsel)")
    (action_tile
      "ndx_filsel"
      "(setq ndx_selndi (get_tile \"filsel\"))(ndx_setone)"
    ) ;_ end of action_tile
    (action_tile "savelst" "(savendxlst)")
    (action_tile "restorelst" "(restorendxlst)")
;;;    (action_tile
;;;      "ndxins_fname"
;;;      "(SETQ ndxins_fname (GET_TILE \"ndxins_fname\"))"
;;;    ) ;_ end of ACTION_TILE
    (action_tile
      "accept"
      "(setq prv_ndxlst cur_ndxlst ndxndx (get_tile\"files\"))(ndx_dclst)(done_dialog)"
    ) ;_ end of action_tile
    (action_tile
      "cancel"
      "(setq prv_ndxlst cur_ndxlst cur_ndxlst nil ndx_filst nil)(rstdir)(done_dialog)"
    ) ;_ end of action_tile
    (action_tile
      "help"
      "(browser_help \"mergendx\")"
    ) ;_ end of action_tile
    (ndx_dirlst)
    (ndx_chkfil)
    (if	prv_ndxlst
      (progn
	(set_tile "selnum"
		  (strcat (itoa (length prv_ndxlst))
			  " Index files selected for merging:"
		  ) ;_ end of strcat
	) ;_ end of set_tile
	(setq cur_ndxlst prv_ndxlst)
	(start_list "ndx_filsel")
	(mapcar 'add_list cur_ndxlst)
	(end_list)
      ) ;_ end of PROGN
    ) ;_ end of IF
    (start_dialog)
    (setq ndx_errtxt nil)
    (if	debug_doslib
      (progn
	(princ "\nallayndx = ")
	(princ allayndx)
	(princ)
      ) ;_ end of PROGN
    ) ;_ end of IF
    (unload_dialog ndx_num)
    (merge_ndx_files)
  ) ;_ end of PROGN
  (if old_mndxecho
    (setvar "CMDECHO" old_mndxecho)
  ) ;_ end of IF
  (if old_mndxexpert
    (setvar "expert" old_mndxexpert)
  ) ;_ end of IF
  (if princdebugstrs
    (princdebugstrs
      (list "End execution of MERGENDX function.\n")
    ) ;_ end of princdebugstrs
  ) ;_ end of IF
  (setq	princprfx
	 (cond
	   ((and princprfx (wcmatch princprfx "`[DEBUG`]   *"))
	    (substr princprfx 1 (- (strlen princprfx) 2))
	   )
	   (debug_princs "[DEBUG]  ")
	   (t "")
	 ) ;_ end of COND
  ) ;_ end of SETQ
  (princ)
  (setq *error* old_mndxerror)
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun ndx_drvlst ()
  (if debug_doslib
    (princ "\nDOS_6 ")
  ) ;_ end of IF
  (setq ndx_avdrvs (dos_drives))
  (if debug_doslib
    (princ "\nDOS_6 ")
  ) ;_ end of IF
  (if (member "A:" ndx_avdrvs)
    (setq ndx_avdrvs (cdr (member "A:" ndx_avdrvs)))
  ) ;_ end of if
  (if (member "B:" ndx_avdrvs)
    (setq ndx_avdrvs (cdr (member "B:" ndx_avdrvs)))
  ) ;_ end of if
  (setq ndx_avdrvs (append (list "with DWG") ndx_avdrvs))
  (if ndx_avdrvs
    (progn
      (start_list "ndx_file_drv")
      (mapcar 'add_list ndx_avdrvs)
      (end_list)
    ) ;_ end of PROGN
  ) ;_ end of IF
  (princ)
) ;_ end of DEFUN
;;;********************************************************************
(defun ndx_dirlst ()
  (if (eq ndx_caldir 4)
    (progn
      (setq ndx_chgdir (get_tile "ndx_dirs"))
      (if debug_doslib
	(princ "\nDOS_7 ")
      ) ;_ end of IF
      (if (eq (substr (nth (atoi ndx_chgdir) ndx_dirs) 1 1) "<")
	(dos_drive (substr (nth (atoi ndx_chgdir) ndx_dirs) 2 2))
	(dos_chdir (nth (atoi ndx_chgdir) ndx_dirs))
      ) ;_ end of if
      (setq ndxdirstr (strcat "Selection path: " (dos_pwdir)))
      (if debug_doslib
	(princ "\nDOS_7 ")
      ) ;_ end of IF
      (princ "\nndxdirstr (2) = ")
      (princ ndxdirstr)
      (princ)
      (set_tile "dirtxt" ndxdirstr)
      (if (/= olddir ndxdirstr)
	(progn
	  (if debug_doslib
	    (princ "\nDOS_8 ")
	  ) ;_ end of IF
	  (setq	ndx_ddirs  (dos_subdir)
		ndx_ddrvs  (dos_drives)
		ndx_d_flst (dos_dir "*.txt")
	  ) ;_ end of setq
	  (if debug_doslib
	    (princ "\nDOS_8 ")
	  ) ;_ end of IF
	  (if (member "A:" ndx_ddrvs)
	    (setq ndx_ddrvs (cdr (member "A:" ndx_ddrvs)))
	  ) ;_ end of if
	  (if (member "B:" ndx_ddrvs)
	    (setq ndx_ddrvs (cdr (member "B:" ndx_ddrvs)))
	  ) ;_ end of if
	  (if ndx_d_flst
	    nil
	    (setq ndx_d_flst (list ""))
	  ) ;_ end of if
	  (if (eq (substr ndxdirstr (1- (strlen ndxdirstr))) ":\\")
	    (if	ndx_ddirs
	      nil
	      (setq ndx_ddirs (list ""))
	    ) ;_ end of if
	    (if	ndx_ddirs
	      (if (member ".." ndx_ddirs)
		nil
		(setq ndx_ddirs (append (list "..") ndx_ddirs))
	      ) ;_ end of if
	      (setq ndx_ddirs (list ".."))
	    ) ;_ end of if
	  ) ;_ end of if
	) ;_ end of progn
      ) ;_ end of if
      (setq ndx_dirini t)
    ) ;_ end of progn
  ) ;_ end of if
  (if ndx_dirini
    (progn
      (setq ndx_dirs (acad_strlsort ndx_ddirs))
      (setq ndx_drvs (acad_strlsort ndx_ddrvs))
      (foreach n ndx_drvs
	(setq ndx_drvs
	       (subst (strcat "<" n ">")
		      n
		      ndx_drvs
	       ) ;_ end of subst
	) ;_ end of setq
      ) ;_ end of foreach
      (ndx_sortfiles)
      (setq olddir ndxdirstr)
      (setq ndx_dirs (append ndx_dirs ndx_drvs))
      (start_list "ndx_dirs")
      (mapcar 'add_list ndx_dirs)
      (end_list)
      (setq ndx_dirini nil)
    ) ;_ end of progn
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(defun setndxfdrv ()
  (if (and ndx_fildrv (member ndx_fildrv ndx_avdrvs))
    (progn
      (setq ndx_drvlst_len (length ndx_avdrvs))
      (setq ndx_fildrv_len (length (member ndx_fildrv ndx_avdrvs)))
      (setq ndx_fdrvndx (itoa (- ndx_drvlst_len ndx_fildrv_len)))
      (set_tile "ndx_file_drv" ndx_fdrvndx)
    ) ;_ end of PROGN
    (progn
      (if (and (member "H:" ndx_avdrvs)
	       (wcmatch (strcase (getvar "dwgname")) "DRAWING*.DWG")
	  ) ;_ end of AND
	(progn
	  (setq	ndx_fdrvndx
		 (itoa (- (length ndx_avdrvs) (length (member "H:" ndx_avdrvs)))
		 ) ;_ end of ITOA
	  ) ;_ end of SETQ
	  (set_tile "ndx_file_drv" ndx_fdrvndx)
	) ;_ end of PROGN
	(if (member (substr (getvar "dwgprefix") 1 2) ndx_avdrvs)
	  (setq	ndx_fdrvndx
		 (itoa
		   (-
		     (length ndx_avdrvs)
		     (length (member (substr (getvar "dwgprefix") 1 2)
				     ndx_avdrvs
			     ) ;_ end of MEMBER
		     ) ;_ end of length
		   ) ;_ end of -
		 ) ;_ end of ITOA
	  ) ;_ end of SETQ
	) ;_ end of IF
      ) ;_ end of IF
    ) ;_ end of PROGN
  ) ;_ end of IF
  (setq ndx_fildrv (nth (atoi ndx_fdrvndx) ndx_avdrvs))
  (if ndx_fdrvndx
    nil
    (setq ndx_fdrvndx "1")
  ) ;_ end of IF
  (set_tile "ndx_file_drv" ndx_fdrvndx)
) ;_ end of defun
;;;********************************************************************
(defun ndx_sortfiles ()
  (if (and ndx_d_flst dos_file (dos_file (car ndx_d_flst)))
    (if	(eq ndx_sortdate "1")
      (progn
	(setq ndx_datesorted_flst
	       (reverse
		 (acad_strlsort
		   (mapcar '(lambda (x)
			      (if (eq (type (nth 2 x)) 'STR)
				(strcat	(substr (nth 2 x) 7 4)
					(substr (nth 2 x) 4 2)
					(substr (nth 2 x) 1 2)
					(nth 0 x)
				) ;_ end of strcat
				(strcat	(substr (rtos (nth 2 x) 2 8) 1 4)
					(substr (rtos (nth 2 x) 2 8) 5 2)
					(substr (rtos (nth 2 x) 2 8) 8 2)
					(nth 0 x)
				) ;_ end of strcat
			      ) ;_ end of IF
			    ) ;_ end of lambda
			   (mapcar 'dos_file ndx_d_flst)
		   ) ;_ end of mapcar
		 ) ;_ end of acad_strlsort
	       ) ;_ end of reverse
	) ;_ end of setq
	(setq ndx_filst (mapcar '(lambda (x) (substr x 9)) ndx_datesorted_flst))
      ) ;_ end of PROGN
      (setq ndx_filst (acad_strlsort ndx_d_flst))
    ) ;_ end of IF
    (if	ndx_d_flst
      (setq ndx_filst (acad_strlsort ndx_d_flst))
    ) ;_ end of IF
  ) ;_ end of IF
  (if ndx_filst
    (progn
      (start_list "ndx_files")
      (mapcar 'add_list ndx_filst)
      (end_list)
    ) ;_ end of PROGN
  ) ;_ end of IF
) ;_ end of DEFUN
;;;********************************************************************
(defun mergendx_key_search (ndx_out_filn / m_indx ksopt)
  (if ndx_out_filn
    (setq ndx_wc_str ndx_out_filn
	  ndx_out_filn nil
    ) ;_ end of setq
    (setq ndx_wc_str (strcase (get_tile "ndx_fedit")))
  ) ;_ end of IF
  (if (> (strlen ndx_wc_str) 4)
    (if	(/= (strcase (substr ndx_wc_str (- (strlen ndx_wc_str) 3) 4))
	    ".txt"
	) ;_ end of /=
      (setq ndx_wc_str (strcat ndx_wc_str ".txt"))
      nil
    ) ;_ end of if
  ) ;_ end of if
  (ndx_dclst)
  (foreach n ndx_d_flst
    (if	cur_ndxlst
      (if (member (strcat ndxdir n) cur_ndxlst)
	nil
	(if (wcmatch (strcase n) (strcase ndx_wc_str))
	  (setq cur_ndxlst (append cur_ndxlst (list (strcat ndxdir n))))
	) ;_ end of if
      ) ;_ end of if
      (if (wcmatch (strcase n) (strcase ndx_wc_str))
	(setq cur_ndxlst (list (strcat ndxdir n)))
      ) ;_ end of if
    ) ;_ end of if
  ) ;_ end of foreach
) ;_ end of defun
;;;********************************************************************
(defun ndx_chkfil ()
  (setq ndxndx (get_tile "ndx_files"))
  (setq ndx_fnxlen (strlen ndxndx))
  (if (= ndx_fnxlen 256)
    (progn
      (set_tile
	"error"
	"Selection exceeds maximum usable. Unselect some files."
      ) ;_ end of set_tile
    ) ;_ end of progn
    (progn
      (set_tile "error" "")
    ) ;_ end of progn
  ) ;_ end of if
  (ndx_dclst)
  (if cur_ndxlst
    (progn
      (setq ndx_fsslen (length cur_ndxlst))
      (set_tile	"selnum"
		(strcat	(itoa ndx_fsslen)
			" Index files selected for merging:"
		) ;_ end of strcat
      ) ;_ end of set_tile
      (start_list "ndx_filsel")
      (mapcar 'add_list cur_ndxlst)
      (end_list)
    ) ;_ end of progn
    (progn
      (set_tile	"selnum"
		"0 Index files selected for merging:"
      ) ;_ end of set_tile
      (set_tile "choice" "")
      (start_list "ndx_filsel")
      (mapcar 'add_list (list ""))
      (end_list)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun setrem ()
  (if cur_ndxlst
    (progn
      (if (and ndx_selndi (/= ndx_selndi ""))
	(setq ndx_selndx (atoi ndx_selndi))
	(setq ndx_selndx nil)
      ) ;_ end of if
      (if ndx_selndx
	(cond
	  ((and (< ndx_selndx (1- (length cur_ndxlst))) (> ndx_selndx 0))
	   (setq cur_ndxlst
		  (append
		    (reverse
		      (cdr (member (nth ndx_selndx cur_ndxlst) (reverse cur_ndxlst)))
		    ) ;_ end of reverse
		    (cdr (member (nth ndx_selndx cur_ndxlst) cur_ndxlst))
		  ) ;_ end of append
	   ) ;_ end of setq
	  )
	  ((eq ndx_selndx 0)
	   (setq cur_ndxlst (cdr cur_ndxlst))
	  )
	  ((eq ndx_selndx (1- (length cur_ndxlst)))
	   (setq cur_ndxlst (reverse (cdr (reverse cur_ndxlst))))
	  )
	) ;_ end of cond
      ) ;_ end of if
      (setq ndx_fsslen (length cur_ndxlst))
      (if (> ndx_selndx (1- ndx_fsslen))
	(if (and (> ndx_fsslen 1) (> ndx_selndx 0))
	  (setq ndx_selndi (itoa (1- ndx_selndx)))
	  (setq ndx_selndi "0")
	) ;_ end of if
      ) ;_ end of if
      (set_tile	"selnum"
		(strcat	(itoa ndx_fsslen)
                        " Index files selected for merging:"
		) ;_ end of strcat
      ) ;_ end of set_tile
      (start_list "ndx_filsel")
      (mapcar 'add_list cur_ndxlst)
      (end_list)
    ) ;_ end of progn
    (progn
      (set_tile	"selnum"
		"0 Index files selected for merging:"
      ) ;_ end of set_tile
      (start_list "ndx_filsel")
      (mapcar 'add_list (list ""))
      (end_list)
    ) ;_ end of progn
  ) ;_ end of if
  (if cur_ndxlst
    (ndx_setone)
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun ndx_setone ()
  (if (and ndx_selndi (/= ndx_selndi ""))
    (progn
      (setq ndx_selndx (atoi ndx_selndi))
      (setq ndx_onefile (nth ndx_selndx cur_ndxlst))
      (if (> (strlen ndx_onefile) 47)
	(progn
	  (setq
	    ndx_onetxt
	     (strcat "..."
		     (substr ndx_onefile (- (strlen ndx_onefile) 44))
	     ) ;_ end of strcat
	  ) ;_ end of setq
	  (if (not (wcmatch ndx_onetxt "*\\*"))
	    (setq ndx_onetxt ndx_onefile)
	    (progn
	      (while (/= (substr ndx_onetxt 1 1) "\\")
		(setq ndx_onetxt (substr ndx_onetxt 2))
	      ) ;_ end of while
	      (setq ndx_onetxt (strcat (substr ndx_onefile 1 3) "..." ndx_onetxt))
	    ) ;_ end of PROGN
	  ) ;_ end of IF
	  (set_tile "choice" ndx_onetxt)
	) ;_ end of progn
	(set_tile "choice" "")
      ) ;_ end of if
      (set_tile "ndx_filsel" ndx_selndi)
    ) ;_ end of progn
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(defun savendxlst ()
  (setq	edfil (getfiled	"Save Merge Indices List"
			(getvar "dwgprefix")
			"ndm"
			5
	      ) ;_ end of getfiled
  ) ;_ end of setq
  (if edfil
    (progn
      (setq opedfil (open edfil "w"))
      (prin1 cur_ndxlst opedfil)
      (close opedfil)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of DEFUN
;;;********************************************************************
(defun restorendxlst ()
  (setq	edfil (getfiled	"Restore Merge Indices List"
			(getvar "dwgprefix")
			"ndm"
			8
	      ) ;_ end of getfiled
  ) ;_ end of setq
  (if edfil
    (progn
      (setq opedfil (open edfil "r"))
      (setq cur_ndxlst (read (read-line opedfil)))
      (close opedfil)
      (setq nfcur_ndxlst nil)
      (foreach n cur_ndxlst
	(if (findfile n)
	  nil
	  (setq nfcur_ndxlst (append nfcur_ndxlst (list n)))
	) ;_ end of if
      ) ;_ end of foreach
      (if nfcur_ndxlst
	(progn
	  (if (eq (length cur_ndxlst) (length nfcur_ndxlst))
	    (progn
	      (set_tile	"error"
			"None of the specified files can be found!"
	      ) ;_ end of SET_TILE
	      (princ
		"\nNone of the specified files can be found.\nMake sure they exist on the specified path before running the script."
	      ) ;_ end of PRINC
	    ) ;_ end of PROGN
	    (progn
	      (set_tile	"error"
			"Some of the specified files cannot be found!"
	      ) ;_ end of SET_TILE
	      (princ
		"\nSome of the specified files cannot be found.\nMake sure they exist on the specified path before running the script."
	      ) ;_ end of PRINC
	    ) ;_ end of PROGN
	  ) ;_ end of IF
	  (princ "\n\n\tThe following files cannot be found:\n")
	  (foreach n nfcur_ndxlst
	    (princ "\n")
	    (princ n)
	  ) ;_ end of foreach
	  (princ "\n")
	  (princ)
	) ;_ end of PROGN
      ) ;_ end of if
      (set_tile	"selnum"
		(strcat	(itoa (length cur_ndxlst))
			" Indices selected for merging:"
		) ;_ end of strcat
      ) ;_ end of set_tile
      (start_list "ndx_filsel")
      (mapcar 'add_list cur_ndxlst)
      (end_list)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of DEFUN
;;;********************************************************************
(defun merge_ndx_files ()
  (if cur_ndxlst
    (progn
      (setq mndx_fname
	     (getfiled
	       "Save Merged Indices to File"
	       (strcat (getvar "dwgprefix") "merged-index.txt")
	       "txt"
	       5
	     ) ;_ end of getfiled
      ) ;_ end of SETQ
      (if (and mndx_fname (setq mndx_fil (open mndx_fname "w")))
	(progn
	  (setq sht_sec_lbl NIL)
	  (foreach n cur_ndxlst
	    (cond
	      ((wcmatch (strcase n) "*01 GENERAL*")
	       (setq sht_sec_lbl "GENERAL")
	      )
	      ((wcmatch (strcase n) "*02 CIVIL*")
	       (setq sht_sec_lbl "CIVIL")
	      )
	      ((wcmatch (strcase n) "*03 STRUCTURAL*")
	       (setq sht_sec_lbl "STRUCTURAL")
	      )
	      ((wcmatch (strcase n) "*04 ARCHITECTURAL*")
	       (setq sht_sec_lbl "ARCHITECTURAL")
	      )
	      ((wcmatch (strcase n) "*05 P&ID*")
	       (setq sht_sec_lbl "P&ID")
	      )
	      ((wcmatch (strcase n) "*06 ENVIRONMENTAL*")
	       (setq sht_sec_lbl "ENVIRONMENTAL")
	      )
	      ((wcmatch (strcase n) "*06 MECHANCIAL*")
	       (setq sht_sec_lbl "MECHANCIAL")
	      )
	      ((wcmatch (strcase n) "*07 TELEMETRY*")
	       (setq sht_sec_lbl "TELEMETRY")
	      )
	      ((wcmatch (strcase n) "*08 ELECTRICAL*")
	       (setq sht_sec_lbl "ELECTRICAL")
	      )
	      ((wcmatch (strcase n) "*09 MECHANICAL*")
	       (setq sht_sec_lbl "MECHANICAL")
	      )
	      ((wcmatch (strcase n) "*09 HVAC*")
	       (setq sht_sec_lbl "HVAC")
	      )
	      ((wcmatch (strcase n) "*10 PLUMBING*")
	       (setq sht_sec_lbl "PLUMBING")
	      )
	      ((wcmatch (strcase n) "*11 FIRE*")
	       (setq sht_sec_lbl "FIRE")
	      )
	      ((wcmatch (strcase n) "*12 LANDSCAPE*")
	       (setq sht_sec_lbl "LANDSCAPE")
	      )
	    ) ;_ end of COND
	    (if	sht_sec_lbl
	      (write-line
		(strcat	"BOGUS DWG IS FOR SECTION LABEL.dwg"
			"\t"
			sht_sec_lbl
			"\t\t"
		) ;_ end of STRCAT
		mndx_fil
	      ) ;_ end of WRITE-LINE
	    ) ;_ end of IF
	    (if
	      (setq this_sec_fil (open n "r"))
	       (progn
		 (while
		   (setq this_line (read-line this_sec_fil))
		    (write-line this_line mndx_fil)
		 ) ;_ end of WHILE
		 (close this_sec_fil)
	       ) ;_ end of PROGN
	    ) ;_ end of IF
	  ) ;_ end of FOREACH
	  (close mndx_fil)
          (ALERT (STRCAT "Merged indices written to:\n" mndx_fname))
	) ;_ end of progn
	(PROGN
	  (IF (AND mndx_fname (EQ (TYPE mndx_fname) 'STR))
	    (ALERT (STRCAT "Unable to open\n" mndx_fname "\nfor writing!"))
	    (ALERT (STRCAT "No filename specified for writing! "))
	  )
	)
      ) ;_ end of IF
    ) ;_ end of progn
    (progn
      (alert "Sheet Index Files were NOT merged! ")
    ) ;_ end of PROGN
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(defun shtndx_layer_ent	(ent_assoc_8_lst /)
  (if c:mklayr
    NIL
    (load "mklayr" "\nFile MKLAYR.LSP not loaded! ")
  ) ;_ end of IF
  (foreach n ent_assoc_8_lst
    (cond ((eq (substr (cdr n) 2 1) "-")
	   (setq layerltype "Continuous")
	  )
	  ((eq (strcase (substr (cdr n) 2 1)) "H")
	   (if (tblsearch "LTYPE" "HIDDEN")
	     (setq layerltype "Hidden")
	     (progn (command "-linetype" "load" "hidden" "acad.lin" "")
		    (setq layerltype "Hidden")
	     ) ;_ end of PROGN
	   ) ;_ end of IF
	   (if (tblsearch "LTYPE" "HIDDEN")
	     NIL
	     (setq layerltype "Continuous")
	   ) ;_ end of IF
	  )
	  ((eq (strcase (substr (cdr n) 2 1)) "C")
	   (if (tblsearch "LTYPE" "CENTER")
	     (setq layerltype "Center")
	     (progn (command "-linetype" "load" "center" "acad.lin" "")
		    (setq layerltype "Center")
	     ) ;_ end of PROGN
	   ) ;_ end of IF
	   (if (tblsearch "LTYPE" "CENTER")
	     NIL
	     (setq layerltype "Continuous")
	   ) ;_ end of IF
	  )
	  ((eq (strcase (substr (cdr n) 2 1)) "D")
	   (if (tblsearch "LTYPE" "DASHED")
	     (setq layerltype "Dashed")
	     (progn (command "-linetype" "load" "dashed" "acad.lin" "")
		    (setq layerltype "Dashed")
	     ) ;_ end of PROGN
	   ) ;_ end of IF
	   (if (tblsearch "LTYPE" "DASHED")
	     NIL
	     (setq layerltype "Continuous")
	   ) ;_ end of IF
	  )
	  ((eq (strcase (substr (cdr n) 2 1)) "I")
	   (if (tblsearch "LTYPE" "HIDDEN2")
	     (setq layerltype "Hidden2")
	     (progn (command "-linetype" "load" "hidden2" "acad.lin" "")
		    (setq layerltype "Hidden2")
	     ) ;_ end of PROGN
	   ) ;_ end of IF
	   (if (tblsearch "LTYPE" "HIDDEN2")
	     NIL
	     (setq layerltype "Continuous")
	   ) ;_ end of IF
	  )
	  ((eq (strcase (substr (cdr n) 2 1)) "P")
	   (if (tblsearch "LTYPE" "PHANTOM")
	     (setq layerltype "Phantom")
	     (progn (command "-linetype" "load" "phantom" "acad.lin" "")
		    (setq layerltype "Phantom")
	     ) ;_ end of PROGN
	   ) ;_ end of IF
	   (if (tblsearch "LTYPE" "PHANTOM")
	     NIL
	     (setq layerltype "Continuous")
	   ) ;_ end of IF
	  )
	  (t (setq layerltype "Continuous"))
    ) ;_ end of COND
    (if	(>= (strlen (cdr n)) 7)
      (progn (setq layercolor
		    (cond ((wcmatch (substr (cdr n) 7 1) "#") (substr (cdr n) 7 1))
			  ((wcmatch (substr (cdr n) 7 1) "@")
			   (cond ((eq (strcase (substr (cdr n) 7 1)) "A") "10")
				 ((eq (strcase (substr (cdr n) 7 1)) "B") "11")
				 ((eq (strcase (substr (cdr n) 7 1)) "C") "12")
				 ((eq (strcase (substr (cdr n) 7 1)) "D") "13")
				 ((eq (strcase (substr (cdr n) 7 1)) "E") "14")
				 ((eq (strcase (substr (cdr n) 7 1)) "F") "15")
				 ((eq (strcase (substr (cdr n) 7 1)) "G") "16")
				 ((eq (strcase (substr (cdr n) 7 1)) "H") "17")
				 ((eq (strcase (substr (cdr n) 7 1)) "I") "18")
				 ((eq (strcase (substr (cdr n) 7 1)) "J") "19")
				 ((eq (strcase (substr (cdr n) 7 1)) "K") "20")
				 ((eq (strcase (substr (cdr n) 7 1)) "L") "21")
				 ((eq (strcase (substr (cdr n) 7 1)) "M") "22")
				 ((eq (strcase (substr (cdr n) 7 1)) "N") "23")
				 ((eq (strcase (substr (cdr n) 7 1)) "O") "24")
				 ((eq (strcase (substr (cdr n) 7 1)) "P") "25")
				 ((eq (strcase (substr (cdr n) 7 1)) "Q") "26")
				 ((eq (strcase (substr (cdr n) 7 1)) "R") "27")
				 ((eq (strcase (substr (cdr n) 7 1)) "S") "28")
				 ((eq (strcase (substr (cdr n) 7 1)) "T") "29")
				 ((eq (strcase (substr (cdr n) 7 1)) "U") "250")
				 ((eq (strcase (substr (cdr n) 7 1)) "V") "251")
				 ((eq (strcase (substr (cdr n) 7 1)) "W") "252")
				 ((eq (strcase (substr (cdr n) 7 1)) "X") "253")
				 ((eq (strcase (substr (cdr n) 7 1)) "Y") "254")
				 ((eq (strcase (substr (cdr n) 7 1)) "Z") "255")
			   ) ;_ end of COND
			  )
			  (t "1")
		    ) ;_ end of COND
	     ) ;_ end of SETQ
      ) ;_ end of PROGN
      (setq layercolor "1")
    ) ;_ end of IF
    (if	layentmake
      NIL
      (load "mklayr" "\nFile MKLAYR.LSP not loaded! ")
    ) ;_ end of IF
    (layentmake (cdr n) layercolor layerltype)
    (if	(tblobjname "LAYER" (cdr n))
      (setvar "CLAYER" (cdr n))
    ) ;_ end of IF
  ) ;_ end of FOREACH
) ;_ end of DEFUN
;;;****************************************************************************
(defun ndx_dclst (/ curndx prvndx)
  (if debug_doslib
    (princ "\nDOS_12 ")
  ) ;_ end of IF
  (setq ndxdir (dos_pwdir))
  (if debug_doslib
    (princ "\nDOS_12 ")
  ) ;_ end of IF
  (if (and ndxndx ndx_filst)
    (progn
      (setq t_len     (strlen ndxndx)
	    t_cnt     1
	    shtcur_ndxlst nil
	    prvndx    nil
      ) ;_ end of setq
      (if (<= t_cnt t_len)
	(setq shtcur_ndxlst (list (read (substr ndxndx 1))))
      ) ;_ end of if
      (while (<= t_cnt t_len)
	(if (eq	(substr	ndxndx
			(if (eq t_cnt 1)
			  1
			  (1- t_cnt)
			) ;_ end of if
			1
		) ;_ end of substr
		" "
	    ) ;_ end of eq
	  (progn
	    (setq curndx (read (substr ndxndx t_cnt)))
	    (if	(= curndx prvndx)
	      nil
	      (setq
		shtcur_ndxlst (append shtcur_ndxlst
				  (list (read (substr ndxndx t_cnt)))
			  ) ;_ end of append
	      ) ;_ end of setq
	    ) ;_ end of if
	    (setq t_cnt (1+ t_cnt))
	    (setq prvndx curndx)
	  ) ;_ end of progn
	  (setq t_cnt (1+ t_cnt))
	) ;_ end of if
      ) ;_ end of while
      (foreach n shtcur_ndxlst
	(if (< n (length ndx_filst))	; added to fix undetermined error
	  (if cur_ndxlst
	    (if	(member (strcat ndxdir (nth n ndx_filst)) cur_ndxlst)
	      nil
	      (setq
		cur_ndxlst (append cur_ndxlst
			       (list (strcat ndxdir (nth n ndx_filst)))
		       ) ;_ end of append
	      ) ;_ end of setq
	    ) ;_ end of if
	    (if	(member (strcat ndxdir (nth n ndx_filst)) cur_ndxlst)
	      nil
	      (setq cur_ndxlst (list (strcat ndxdir (nth n ndx_filst))))
	    ) ;_ end of if
	  ) ;_ end of if
	) ;_ end of IF
      ) ;_ end of foreach
    ) ;_ end of progn
    nil
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(defun rstdir ()
  (if debug_doslib
    (princ "\nDOS_13 ")
  ) ;_ end of IF
  (if (eq (dos_drive) ndxorgdrv)
    nil
    (dos_drive ndxorgdrv)
  ) ;_ end of if
  (if (eq (dos_pwdir) ndxorgdir)
    nil
    (dos_chdir (substr ndxorgdir 4))
  ) ;_ end of if
  (if debug_doslib
    (princ "\nDOS_13 ")
  ) ;_ end of IF
) ;_ end of defun
;;;********************************************************************

;|Visual LISP Format Options (72 2 40 2 T "end of " 60 9 1 0 0 T T nil T)
 ***Don't add text below the comment!***|;
